//Mount a player to a brick with an event
//Made by Cruxeis, BL_ID 35041

function fxDTSBrick::mountPlayerToBrick(%this, %effect, %client)
{
	if(!isObject(%player = %client.player))
		return;
	%client.preMountTransform = %player.getTransform();
	if(!isObject(%this.mountStatic))
	{
		%this.mountStatic = new staticShape()
		{
			datablock = emptyShapeData;	
			position = VectorAdd(%this.getPosition(), "0 0" SPC %this.getDatablock().brickSizeZ * 0.1);
			rotation = %rotation;
			mountBrick = %this;
		};
		%this.numMountedPlayers = 0;
	}
	%this.mountStatic.mountObject(%player, 1);
	if(%effect)
		%player.teleportEffect();
}

function Player::mountToBrick(%this, %brickname, %effect)
{
	if(trim(%brickname) $= "")
		return;
	%this.client.preMountTransform = %this.getTransform();
	%group = "brickGroup_" @ %this.client.getBLID();
	%count = %group.getCount();
	for(%i = 0; %i < %count; %i++)
	{
		%obj = %group.getObject(%i);
		if(getSubStr(%obj.getName(), 1, strlen(%obj.getName())) $= %brickname)
		{
			if(!isObject(%obj.mountStatic))
			{
				%obj.mountStatic = new staticShape()
				{
					datablock = emptyShapeData;
					position =  VectorAdd(%obj.getPosition(), "0 0" SPC %obj.getDatablock().brickSizeZ * 0.1);
					rotation = %rotation;
					mountBrick = %obj;
				};
				%obj.numMountedPlayers = 0;
			}
			%obj.mountStatic.mountObject(%this, 1);
		}
	}
	if(%effect)
		%this.teleportEffect();
}

function fxDTSBrick::unMountAll(%this, %effect, %client)
{
	if(isObject((%static = %this.mountStatic))) 
	{
		%count = clientGroup.getCount();
		for(%i = 0; %i < %count; %i++)
		{
			if(isObject((%player = clientGroup.getObject(%i).player)))
			{
				if(%player.getObjectMount() == %static)
					%static.unMountObject(%player);
			}
		}
	}
	if(%effect)
		%client.player.teleportEffect();
}

function Player::mountReturn(%this, %effect)
{
	if(isObject(%mount = %this.getObjectMount()))
	{
		if(isObject(%mount.mountBrick))
			%mount.unMountObject(%this);
		%this.setTransform(%this.client.preMountTransform);
	}
	if(%effect)
		%this.teleportEffect();
}

function fxDTSBrick::returnAllPlayers(%this, %effect)
{
	if(isObject(%mount = %this.mountStatic))
	{
		%count = clientGroup.getCount();
		for(%i = 0; %i < %count; %i++)
		{
			if(!isObject(%player = clientGroup.getObject(%i).player))
				continue;
			if(%player.getObjectMount() != %mount)
				continue;
			%mount.unMountObject(%player);
			%player.setTransform(%player.client.preMountTransform);
			if(%effect)
				%player.teleportEffect();
		}
	}
}	

package mountToBrick {

function fxDTSBrick::onDeath(%this)
{
	if(isObject(%this.mountStatic))
		%this.mountStatic.delete();
	parent::onDeath(%this);
}

function Armor::onUnMount(%this, %obj, %mount, %node)
{
	if(isObject(%brick = %mount.mountBrick))
	{
		$InputTarget_["Self"] = %brick;
		$InputTarget_["Client"] = %obj.client;
		$InputTarget_["Player"] = %obj.client.player;
		if(getMinigameFromObject(%brick) == getMinigameFromObject(%obj.client))
			$InputTarget_["Minigame"] = getMinigameFromObject(%brick);
		else
			$InputTarget_["Minigame"] = 0;
		%brick.processInputEvent("onPlayerUnMount");
	}
	parent::onUnMount(%this, %obj, %mount, %node);
}

function Armor::onMount(%this, %obj, %mount, %node)
{
	if(isObject(%brick = %mount.mountBrick))
	{
		$InputTarget_["Self"] = %brick;
		$InputTarget_["Client"] = %obj.client;
		$InputTarget_["Player"] = %obj.client.player;
		if(getMinigameFromObject(%brick) == getMinigameFromObject(%obj.client))
			$InputTarget_["Minigame"] = getMinigameFromObject(%brick);
		else
			$InputTarget_["Minigame"] = 0;
		%brick.processInputEvent("onPlayerMount", %obj.client);
	}
	parent::onMount(%this, %obj, %mount, %node);
}

};

activatePackage(mountToBrick);

registerOutputEvent("fxDTSBrick", "mountPlayerToBrick", "bool", true);
registerOutputEvent("fxDTSBrick", "unMountAll", "bool", true);
registerOutputEvent("fxDTSBrick", "returnAllPlayers", "bool", false);
registerOutputEvent("Player", "mountToBrick", "string 100 75" TAB "bool", false);
registerOutputEvent("Player", "mountReturn", "bool", false);
registerInputEvent("fxDTSBrick", "onPlayerMount", "Self fxDTSBrick" TAB "Player Player" TAB "Client GameConnection" TAB "MiniGame MiniGame");
registerInputEvent("fxDTSBrick", "onPlayerUnMount", "Self fxDTSBrick" TAB "Player Player" TAB "Client GameConnection" TAB "MiniGame MiniGame");


datablock staticShapeData(emptyShapeData)
{
	shapeFile = "base/data/shapes/empty.dts";
};


